unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  resource, resreader,
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;
  //resource, resreader;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ShowImages: TButton;
    Button_auslesen: TButton;
    Image1: TImage;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure ShowImagesClick(Sender: TObject);
    procedure Button_auslesenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    function ReadResName(Idx: integer): string;
    function ResCount: integer;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}
{$R images.res}
{ TForm1 }

procedure TForm1.Button_auslesenClick(Sender: TObject); //siehe: https://www.lazarusforum.de/viewtopic.php?p=126490#p126490
var res     : TResources;
    stream  : TFileStream;
    reader  : TAbstractResourceReader;
    i       : Integer;
    item    : TAbstractResource;
begin
  Memo1.Clear;
  res := TResources.Create;
  stream := TFileStream.Create('images.res', fmOpenRead);
  try
    reader := TResources.FindReader(stream);
    res.LoadfromStream(stream, reader);
    for i := 0 to res.Count-1 do
    begin
      item := res.Items[i];
      Memo1.Lines.Add(Format('%s (%s)', [item.Name.Name, item._Type.Name]));
    end;
  finally
    reader.Free;
    stream.Free;
    res.Free;
  end;
end;

function TForm1.ResCount : integer;
var res     : TResources;
    stream  : TFileStream;
    reader  : TAbstractResourceReader;
begin
 res := TResources.Create;
 stream := TFileStream.Create('images.res', fmOpenRead);
 try
   reader := TResources.FindReader(stream);
   res.LoadfromStream(stream, reader);
   Result := res.Count;
 finally
  reader.Free;
  stream.Free;
  res.Free;
 end;
end;

function TForm1.ReadResName (Idx : integer) : string;
var res     : TResources;
    stream  : TFileStream;
    reader  : TAbstractResourceReader;
    item    : TAbstractResource;
begin
 res := TResources.Create;
 stream := TFileStream.Create('images.res', fmOpenRead);
  try
    reader := TResources.FindReader(stream);
    res.LoadfromStream(stream, reader);
    item := res.Items[Idx];
    Result := item.Name.Name;
  finally
    reader.Free;
    stream.Free;
    res.Free;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const i : integer = 0;
begin
 caption := ReadResName(i);
 Image1.Picture.LoadFromResourceName(hInstance,ReadResName(i));
 inc(i);
 if i = (ResCount-1) then i:=0;
end;

procedure TForm1.ShowImagesClick(Sender: TObject);
begin
 Timer1.Enabled:= true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Timer1.Enabled:= false;
end;

end.

